## busybox 1.35.0

=== debian/changelog ===
busybox (1:1.35.0-4ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - debian/config/pkg/deb
      debian/config/pkg/static:
      Enable chpasswd in standard and static builds (needed by LXC).
    - Move zz-busybox to busybox-initramfs to ensure we get links to all
      the tools we need, stop shipping it anywhere else.
    - Prefer busybox commands over klibc commands where there is duplication.
    - Add Ubuntu configuration for busybox binaries.
    - Enable the new klibc utility implementations, nuke and run-init
      in the initramfs package; and also enable reboot.  Doesn't yet make
      klibc-utils irrelevant - we still use ipconfig, fstype, and nfsmount
      - but it moves us much closer and should save a little bit of disk
      space.
    - debian/config/pkg/initramfs: Enable the date applet with the same
      options as the other variants for use in fixrtc and casper scripts.
    - debian/config/pkg/initramfs
      debian/tree/busybox/usr/share/initramfs-tools/hooks/zz-busybox:
      Enable TLS in initramfs flavour of wget applet, requires openssl
    - Add dirname from coreutils to the initramfs

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Fri, 23 Nov 2022 15:44:44 +0000

busybox (1:1.35.0-4) unstable; urgency=medium

  * static build: disable blkid applet (CONFIG_BLKID, #1023501)

    Since static build has CONFIG_FEATURE_PREFER_APPLETS=y, enabling
    any utility which is also provided by the system in other ways
    can be risky, since busybox shell will choose its applet version
    instead of running the actual utility, even if that utility file
    exists in $PATH. After enabling blkid, we effectively overwrote
    blkid from libblkid as used in initramfs. The result was non-
    working udev rules for block devices (not creating /dev/disk/by-*/),
    and the system's unbootable.

    Disable it for now at least on static build.
    Closes: 1023501

  * d/rules: recognize "terse" in $DEB_BUILD_OPTIONS to disable verbose build

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 06 Nov 2022 11:27:04 +0300

busybox (1:1.35.0-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + udhcpc: Add Multi-Arch: same.

  [ Philip Hands ]
  * explicitly enable lintian
  * disable repotest's fileordering variation
  * stop running busybox tests in reprotest variations

  [ Michael Tokarev ]
  * deb: enable fdisk applet the same way as done in static config
  * deb,static: enable blkid applet (useful for rescue purposes)
  * deb,static: enable findfs applet (useful for rescue purposes)
  * d/rules: use diff instead of cmp to compare config files
    (makes differences, if any, to be immediately visible)
  * support building on non-linux. 3 patches for upstream:
    - platform-linux.diff - resurrect PLATFORM_LINUX and make it automatic
    - fix-non-linux-build.patch - for missing O_DIRECT & IP_PKTINFO
    - use-libresolv-on-non-linux-too.patch - -lresolv for nslookup
  * adjust configs to include the new symbol
  * d/rules: stop messing with "select PLATFORM_LINUX" thing
  * d/rules: stop linking source into build subdir
  * d/rules: fix testsuite run with no source in build dir
  * d/rules: remove .kernelrelease in clean (leftover)
  * d/rules: move build directory from debian/build/ to b/
  * d/rules: s/${DIR}/$d/g
  * d/config/os/hurd: remove nonexisting FEATURE_INITRD (see #593865)
  * d/control: do not use ${shlib:Depends} for busybox-static

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 04 Nov 2022 20:41:55 +0300

busybox (1:1.35.0-2) unstable; urgency=medium

  * Team upload.

  [ Michael Tokarev ]
  * configs: enable (fast) sha3sum for regular and static builds (#1012828)

  [ Philip Hands ]
  * enable base64 in udeb
  * enable salsa-CI (via branch2repo)
  * remove redundant triggers (dh_installinitramfs creates them)
  * fix lintian mismatch override
  * refresh fuzzy patches

 -- Philip Hands <phil@hands.com>  Fri, 02 Sep 2022 17:10:44 +0200

busybox (1:1.35.0-1ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - debian/config/pkg/deb
      debian/config/pkg/static:
      Enable chpasswd in standard and static builds (needed by LXC).
    - Move zz-busybox to busybox-initramfs to ensure we get links to all
      the tools we need, stop shipping it anywhere else.
    - Prefer busybox commands over klibc commands where there is duplication.
    - Add Ubuntu configuration for busybox binaries.
    - Enable the new klibc utility implementations, nuke and run-init
      in the initramfs package; and also enable reboot.  Doesn't yet make
      klibc-utils irrelevant - we still use ipconfig, fstype, and nfsmount
      - but it moves us much closer and should save a little bit of disk
      space.
    - debian/config/pkg/initramfs: Enable the date applet with the same
      options as the other variants for use in fixrtc and casper scripts.
    - debian/config/pkg/initramfs
      debian/tree/busybox/usr/share/initramfs-tools/hooks/zz-busybox:
      Enable TLS in initramfs flavour of wget applet, requires openssl
    - Add dirname from coreutils to the initramfs
  * Dropped changes, included in Debian:
    - debian/patches/CVE-2021-28831.patch: fix DoS if gzip is corrupt in
      archival/libarchive/decompress_gunzip.c.
    - debian/patches/CVE-2021-42374.patch: fix a case where we could read


=== debian/control ===
Source: busybox
Priority: optional
Section: utils
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders:
 Chris Boot <bootc@debian.org>,
 Christoph Biedl <debian.axhn@manchmal.in-ulm.de>,
 Michael Tokarev <mjt@tls.msk.ru>,
Build-Depends: debhelper-compat (= 13),
 zip <!nocheck>
Standards-Version: 4.1.5
Vcs-Git: https://salsa.debian.org/installer-team/busybox.git
Vcs-Browser: https://salsa.debian.org/installer-team/busybox
Homepage: http://www.busybox.net
Rules-Requires-Root: no

Package: busybox
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: busybox-static
Replaces: busybox-static
Description: Tiny utilities for small and embedded systems
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 This package installs the BusyBox binary but does not install
 symlinks for any of the supported utilities. Some of the utilities
 can be used in the system by installing the busybox-syslogd,
 busybox-udhcpc or busybox-udhcpd packages.

Package: busybox-static
Architecture: any
Built-Using: ${built-using}
Depends: ${misc:Depends}
Conflicts: busybox
Replaces: busybox
Provides: busybox
Section: shells
Description: Standalone rescue shell with tons of builtin utilities
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.).  The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-static provides you with a statically linked simple stand alone shell
 that provides all the utilities available in BusyBox. This package is
 intended to be used as a rescue shell, in the event that you screw up your
 system. Invoke "busybox sh" and you have a standalone shell ready to save
 your system from certain destruction. Invoke "busybox", and it will list the
 available builtin commands.

Package: busybox-initramfs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: shells
Description: Standalone shell setup for initramfs
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-initramfs provides a simple stand alone shell that provides
 only the basic utilities needed for the initramfs.

Package: busybox-udeb
Package-Type: udeb
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: debian-installer
Description: Tiny utilities for the debian-installer
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-udeb is used by the debian-installer, so unless you are working on
 the debian-installer, this package is not for you. Installing this
 on your Debian system is a very, very bad idea. You have been warned.

Package: busybox-syslogd
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends:
 busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}),
 lsb-base,
 ${misc:Depends},
Provides: linux-kernel-log-daemon, system-log-daemon
Conflicts: linux-kernel-log-daemon, system-log-daemon
Description: Provides syslogd and klogd using busybox
 The system log daemon is responsible for providing logging of
 messages received from programs and facilities on the local host as
 well as from remote hosts.
 .
 The kernel log daemon listens to kernel message sources and is
 responsible for prioritizing and processing operating system
 messages.
 .
 The busybox implementation of the syslogd is particular useful on
 embedded, diskless (netboot) or flash disk based systems because it
 can use a fixed size ring buffer for logging instead of saving logs
 to the disk or sending it to remote logging servers. The ring buffer
 can be read using the (also busybox based) command logread.
 .
 This package provides the glue to the busybox syslogd and klogd to be
 used in the system by providing the appropriate symbolic links and
 scripts.

Package: udhcpc
Section: net
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}),
 ${misc:Depends},
Multi-Arch: same
Description: Provides the busybox DHCP client implementation
 Busybox contains a very small yet fully functional RFC compliant DHCP
 client formerly known as udhcpc.
 .
 This package contains the glue to use the busybox udhcpc as DHCP
 client in the system by providing the appropriate symbolic links and
 scripts.

Package: udhcpd
Section: net
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}),
 lsb-base,
 ${misc:Depends},
Provides: dhcpd
Description: Provides the busybox DHCP server implementation
 Busybox contains a very small yet fully function RFC compliant DHCP
 server formerly known as udhcpd.
 .
 This package contains the glue to use the busybox udhcpd as DHCP
 server in the system by providing the appropriate symbolic links and
 scripts.

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# in order to keep output non-intermixed together, disable parallel building
# of different targets in this d/rules but allow running parallel submakes
.NOTPARALLEL:
# DEB_BUILD_OPTIONS=parallel=N
MAKEFLAGS += $(subst parallel=,-j,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
V = $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)

# Activate full hardening build flags
export DEB_BUILD_MAINT_OPTIONS := hardening=+all
# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif
include /usr/share/dpkg/default.mk

##############################################################################

TESTSUITE_ENV = SKIP_KNOWN_BUGS=y
#TESTSUITE_ENV = VERBOSE=y
# always run tests in UTF8 mode to verify unicode support
TESTSUITE_ENV += LANG=C.UTF-8 LC_ALL=C.UTF-8
TESTSUITE_ENV += SKIP_INTERNET_TESTS=y
# Required for testsuite/taskset.tests
TESTSUITE_ENV += SHELL='${SHELL}'
# dash echo does not understand -e, bb builds its own in this case
TESTSUITE_ENV += ECHO=/bin/echo

# build directory
b = b

# which flavours to build
flavours = deb static udeb initramfs

ifneq (${DEB_HOST_GNU_TYPE},${DEB_BUILD_GNU_TYPE})
export CROSS_COMPILE = ${DEB_HOST_GNU_TYPE}-
endif

# We filter the following from CFLAGS:
# -O2
#   to use the optimization setting from busybox's configuration and build
#   system, causing it to use -Os. This reduces built binaries' size
#   considerably, making it easier to fit on space constrained systems.
CFLAGS := $(filter-out -O2, ${CFLAGS})

# Avoid Kconfig outputting the timestamp into generated configuration files. We
# use this to compare against the configuration files in debian/config/pkg for
# builds on Linux so that we can detect upstream configuration changes (e.g.
# added applets).
export KCONFIG_NOTIMESTAMP=1

install-indep install-arch install \
binary-indep binary-arch binary \
: %:
	dh $@

##############################################################################

configure: $(patsubst %,$b/%/.stamp-setup, ${flavours})
$(addprefix configure-,${flavours}): configure-%: $b/%/.stamp-setup
.PHONY: configure $(addprefix configure-,${flavours})

$b/%/.stamp-setup: d = $b/$*
$b/%/.stamp-setup:
	rm -rf $d
	mkdir -p $d

# Generate the .config file. First variable assignment wins.
# Several steps..

# 1, put any arch-specific overrides so they will have higher precedence
# should be empty for linux
	cat debian/config/os/${DEB_HOST_ARCH_OS} > $d/.config

# 2, use the flavour-specific base config file.
	cat debian/config/pkg/$* >> $d/.config

# 3, sort out the result using oldconfig Kbuild machinery and generate Makefile
	yes "" | ${MAKE} -C $d -f "${CURDIR}/Makefile" KBUILD_SRC="${CURDIR}" silentoldconfig V=$V

# 4, on linux platform only, compare the re-generated config to the shipped
# config in the package in order to catch new/changed upstream options.
ifeq (linux,${DEB_HOST_ARCH_OS})
	diff -u debian/config/pkg/$* $d/.config
endif

	ln -s .config $@

##############################################################################

build-arch: $(patsubst %,$b/%/.stamp-build, ${flavours})
build: build-arch
$(addprefix build-,${flavours}): build-%: $b/%/.stamp-build
build-indep:
.PHONY: build build-arch build-indep $(addprefix build-,${flavours})

# busybox build procedure is very sensitive for (environment) variables, it will
# remake everything if CFLAGS or LD has changed between build and install phases
# (and install depends on build, so busybox will be rebuilt during install if
# any env var has changed).
# Another problem is that upstream build system (as of 1.35) can not take more
# than a single target to build when building in parallel, the build fails in
# this case.  So we can not ask it for `all install' for example.
# To work around this, we use the upstream makefile only at the build stage,
# providing all environment explicitly in a single place.
# And installing will be done without the help from upstream makefiles,
# based on the information in the generated busybox.links file.

$b/%/.stamp-build: d = $b/$*
$b/%/.stamp-build: $b/%/.stamp-setup
	${MAKE} -C $d all \
	 SKIP_STRIP=y \
	 BB_EXTRA_VERSION="${DEB_VENDOR} ${DEB_VERSION}" \
	 CONFIG_EXTRA_CFLAGS='${CFLAGS} ${CPPFLAGS}' \
	 CONFIG_EXTRA_LDFLAGS='${CFLAGS} ${LDFLAGS}' \
	 V=$V
	${MAKE} -C $d busybox.links
	ln -sf busybox $@

##############################################################################

build-arch: $(if $(filter nocheck,${DEB_BUILD_OPTIONS}),,test-deb)
$(addprefix test-,${flavours}): test-%: $b/%/.stamp-test
.PHONY: $(addprefix test-,${flavours})

$b/%/.stamp-test: d = $b/$*
$b/%/.stamp-test: $b/%/.stamp-build
	@echo ======== running testsuite in $d ========
	@if [ ! -f $d/testsuite/.setup ]; then \
	    rm  -rf $d/testsuite ; \
	    cp -al testsuite $d/ ; \
	    rm -f $d/testsuite/mdev.tests; \
	    [ ! -f debian/testsuite-${DEB_HOST_ARCH_OS}.diff ] || \
		patch -p1 -d $d/ \
		  < debian/testsuite-${DEB_HOST_ARCH_OS}.diff ; \
	    touch $d/testsuite/.setup ; \
	fi
	cd $d/testsuite && ${TESTSUITE_ENV} ./runtest
	touch $@

##############################################################################

clean:
	dh_clean $b/
	rm -f .kernelrelease # leftover from the build process
.PHONY: clean

##############################################################################

override_dh_auto_install:

override_dh_install: $(patsubst %,$b/%/.stamp-build, ${flavours})
	dh_install
	dh_install -pbusybox ${b}/deb/busybox /bin
	dh_install -pbusybox-static ${b}/static/busybox /bin
	dh_install -pbusybox-udeb ${b}/udeb/_install/* /

override_dh_installdocs:
	dh_installdocs
	dh_installdocs -pbusybox docs/syslog.conf.txt docs/mdev.txt
	dh_installdocs -pbusybox-static docs/syslog.conf.txt docs/mdev.txt
	dh_install -pbusybox-static $b/static/busybox bin/
	dh_install -pbusybox-static $b/static/docs/busybox.1 usr/share/man/man1/

	dh_install -pbusybox-udeb $b/udeb/busybox bin/
# for udeb we also need links. But we can not easily use `make install'
# (see comment above). So we run the install rules directly here:
	dh_link -pbusybox-udeb \
	  $$(grep -v sbin/init $b/udeb/busybox.links | sed 's|^|/bin/busybox |')

override_dh_installinit:
	dh_installinit -pbusybox-syslogd
	dh_installinit -pbusybox-syslogd --name=busybox-klogd

# busybox-initramfs
	dh_install -pbusybox-initramfs ${b}/initramfs/busybox /usr/lib/initramfs-tools/bin/
	install -D debian/tree/busybox/usr/share/initramfs-tools/hooks/zz-busybox debian/busybox-initramfs/usr/share/initramfs-tools/hooks/zz-busybox-initramfs

ifeq (linux,$(DEB_HOST_ARCH_OS))
# udhcpc
# udhcpd
	dh_installinit -pudhcpd --onlyscripts
endif

override_dh_gencontrol:
# after shlibdeps finished, grab ${shlibs:Depends} from busybox package
# and transform it into Built-Using field (also dpkg-query bug #588505)
	if [ -f debian/busybox.substvars ]; then \
	  pkgs=$$(sed -n -e's/([^)]*)//g' -e's/,//g' -e's/^shlibs:Depends=//p' debian/busybox.substvars); \
	  srcs=; for p in $$pkgs; do \
	    srcs="$$srcs $$(dpkg-query -f '$${source:Package} (= $${source:Version}),' -W $$p)"; \
	  done ; \
	  echo "built-using=$$srcs" >> debian/busybox-static.substvars ; \
	fi
	dh_gencontrol

## busybox 1.36.1

=== Makefile ===
VERSION = 1
PATCHLEVEL = 36
SUBLEVEL = 1
EXTRAVERSION =
NAME = Unnamed

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into busybox), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call sparse as part of compilation of C files
# Use 'make C=1' to enable sparse checking

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

PHONY += $(MAKECMDGOALS)

$(filter-out _all,$(MAKECMDGOALS)) _all:
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	KBUILD_EXTMOD="$(KBUILD_EXTMOD)" -f $(CURDIR)/Makefile $@

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH TOPDIR


# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile

CROSS_COMPILE ?=
# bbox: we may have CONFIG_CROSS_COMPILER_PREFIX in .config,
# and it has not been included yet... thus using an awkward syntax.
ifeq ($(CROSS_COMPILE),)
CROSS_COMPILE := $(shell grep ^CONFIG_CROSS_COMPILER_PREFIX .config 2>/dev/null)
CROSS_COMPILE := $(subst CONFIG_CROSS_COMPILER_PREFIX=,,$(CROSS_COMPILE))
CROSS_COMPILE := $(subst ",,$(CROSS_COMPILE))
#")
endif

# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and
# SUBARCH is subsequently ignored.

ifneq ($(CROSS_COMPILE),)
SUBARCH := $(shell echo $(CROSS_COMPILE) | cut -d- -f1 | sed 's:^.*/::g')
else
SUBARCH := $(shell uname -m)
endif
SUBARCH := $(shell echo $(SUBARCH) | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
					 -e s/arm.*/arm/ -e s/sa110/arm/ \
					 -e s/s390x/s390/ -e s/parisc64/parisc/ \
					 -e s/ppc.*/powerpc/ -e s/mips.*/mips/ )

ARCH ?= $(SUBARCH)

# Architecture as present in compile.h
UTS_MACHINE := $(ARCH)

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

# 	Decide whether to build built-in, modular, or both.
#	Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are uptodate before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing wil be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

HOSTCC  	= gcc
HOSTCXX  	= g++
HOSTCFLAGS	:=
HOSTCXXFLAGS	:=
# We need some generic definitions
include $(srctree)/scripts/Kbuild.include

HOSTCFLAGS	+= $(call hostcc-option,-Wall -Wstrict-prototypes -O2 -fomit-frame-pointer,)
HOSTCXXFLAGS	+= -O2

# For maximum performance (+ possibly random breakage, uncomment
# the following)

MAKEFLAGS += -rR

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE)as
CC		= $(CROSS_COMPILE)gcc
LD		= $(CC) -nostdlib
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
PKG_CONFIG	?= $(CROSS_COMPILE)pkg-config
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ -Wbitwise $(CF)
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  = -r
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=


# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
CFLAGS		:= $(CFLAGS)
# Added only to final link stage of busybox binary
CFLAGS_busybox	:= $(CFLAGS_busybox)
CPPFLAGS	:= $(CPPFLAGS)
AFLAGS		:= $(AFLAGS)
LDFLAGS		:= $(LDFLAGS)
LDLIBS		:=

# Read KERNELRELEASE from .kernelrelease (if it exists)
KERNELRELEASE = $(shell cat .kernelrelease 2> /dev/null)
KERNELVERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

export	VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION \
	ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE \
	HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE
export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE
export FLTFLAGS

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# Files to ignore in find ... statements

RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS -o -name .pc -o -name .hg -o -name .git \) -prune -o
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

# This target generates Kbuild's and Config.in's from *.c files
PHONY += gen_build_files
gen_build_files: $(wildcard $(srctree)/*/*.c) $(wildcard $(srctree)/*/*/*.c) $(wildcard $(srctree)/embed/*)
	$(Q)$(srctree)/scripts/gen_build_files.sh $(srctree) $(objtree)

# bbox: we have helpers in applets/
# we depend on scripts_basic, since scripts/basic/fixdep
# must be built before any other host prog
PHONY += applets_dir
applets_dir: scripts_basic gen_build_files include/config/MARKER
	$(Q)$(MAKE) $(build)=applets

applets/%: applets_dir ;

PHONY += outputmakefile
# outputmakefile generates a Makefile in the output directory, if using a

=== debian/changelog ===
busybox (1:1.36.1-6ubuntu3) noble; urgency=medium

  * d/p/reverse-cbq.patch: Re-instate defines from removed kernel headers
    (LP: #2062414)

 -- Dave Jones <dave.jones@canonical.com>  Fri, 19 Apr 2024 10:16:16 +0200

busybox (1:1.36.1-6ubuntu2) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 17:55:04 +0200

busybox (1:1.36.1-6ubuntu1) noble; urgency=medium

  * Remove some documentation from the busybox-static package.
  * Merge with Debian unstable. Remaining changes:
    - Add busybox-initramfs binary package and initramfs flavour:
      - Add dirname from coreutils to the initramfs
      - Enable the new klibc utility implementations, nuke and run-init
        in the initramfs package; and also enable reboot.  Doesn't yet make
        klibc-utils irrelevant - we still use ipconfig, fstype, and nfsmount
        - but it moves us much closer and should save a little bit of disk
        space.
      - Enable TLS in initramfs flavour of wget applet, requires openssl
      - debian/config/pkg/initramfs: Enable the date applet with the same
        options as the other variants for use in fixrtc and casper scripts.
      - Prefer busybox cmds over klibc cmds where there is duplication.
      - Move zz-busybox to busybox-initramfs to ensure we get links to all
        the tools we need, stop shipping it anywhere else.
      - d/tree/busybox/usr/share/initramfs-tools/hooks/zz-busybox:
        Copy certs and openssl config for the casper+busybox-initramfs case.
      - Add Ubuntu configuration for busybox binaries.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - d/config/pkg/{deb,static}: Enable chpasswd (needed by LXC).

 -- Dan Bungert <daniel.bungert@canonical.com>  Tue, 12 Dec 2023 13:42:48 -0700

busybox (1:1.36.1-6) unstable; urgency=medium

  [ Michael Tokarev ]
  * d/rules: override-dh_installsystemd: s/-indep//
  * d/busybox-syslogd.{service,init}: umask 026, not 024
  * adjust paths to busybox binary after move
    /bin/busybox => /usr/bin/busybox
  * Upload to unstable.

  [ Chris Boot ]
  * Update binary path in lintian overrides.

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 30 Nov 2023 15:32:46 +0300

busybox (1:1.36.1-6~exp.1) experimental; urgency=medium

  * Coordinated move of binaries into /usr.
  * Upload to experimental.

 -- Chris Boot <bootc@debian.org>  Thu, 23 Nov 2023 12:35:38 +0000

busybox (1:1.36.1-5) unstable; urgency=medium

  * config:
   - deb: turn off embedded scripts (not used anyway)
   - deb: enable minimal dpkg (the same as in static config) (+lintian tag)
   - deb: enable passwd, su, sulogin (the same as in static config)
   - deb: enable ed (the same as in static config)
   - deb: enable cron & crontab (the same as in static config)
   - deb: enable tunctl (the same as in static config)
   - deb: set ifupdown udhcpc options to -R -n (the same as in static config)
   - deb: enable tc (traffic control) applet, the same as in static build
   - deb: enable ifupdown options like of static build
   - static: enable tftp progress bar (the same as in deb config)
   At this point, deb&static configs are almost the same, with the differences:
    - static (&libgcc), prefer_applets, standalone_shell, bb_passwd & bb_shadow
    - deb has no blkid (#1023501) and no telnetd (#881626)
   - deb,static: disable unusual ipneigh applet (but keep ip neigh)
   - deb,static,udeb: enable udhcpc6 (#1036446)
   - deb,static: enable wget timeout (-T) option
  * spelling.diff: forward upstream
  * d/*.lintian-overrides: +spelling-error-in-binary iif if [bin/busybox]
    (this is Input InterFace)
  * added udhcpd.service
  * update tags for debian/patches/syslogd-option_mask32.patch
  * busybox-syslogd*.service: update Documentation: settings
  * make busybox-syslogd socket-activated to work correctly under systemd
    (syslogd-make-it-optionally-systemd-socket-activated.patch,
    busybox-syslogd.service changes)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 18 Nov 2023 19:53:06 +0300

busybox (1:1.36.1-4) unstable; urgency=medium

  * Revert "Revert recent changes that have broken syslogd in d-i."
    Thank you Steve, others for the good work and patience!
  * syslogd-fix-breakage-caused-by-daemonize-_after_-ini.patch
    (use upstream patch instead of syslogd-avoid-nulling-devlog.patch.
    it looks like upstream rewrites patch authorship with their own)
  * syslogd-option_mask32.patch (Actually fixes #1039710 with remote logging)
  * syslogd: make logfiles owned by root:adm mode 0640
  * syslog.conf: match current rsyslog.conf
  * install-fix-chown-resetting-suid-sgid-bits-from-chmod.patch

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 13 Nov 2023 12:12:27 +0300

busybox (1:1.36.1-3.1) unstable; urgency=medium

  * NMU
  * Revert recent changes that have broken syslogd in d-i.
    Closes: #1039710

 -- Steve McIntyre <93sam@debian.org>  Thu, 03 Aug 2023 21:22:44 +0100

busybox (1:1.36.1-3ubuntu1) mantic; urgency=medium

  * Refresh d/config/pkg/initramfs for new upstream version.  New values based
    on 'deb' config.
  * Drop delta to the udeb config
  * Merge from Debian unstable. Remaining changes:
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - debian/config/pkg/deb
      debian/config/pkg/static:
      Enable chpasswd in standard and static builds (needed by LXC).
    - Move zz-busybox to busybox-initramfs to ensure we get links to all
      the tools we need, stop shipping it anywhere else.
    - Prefer busybox commands over klibc commands where there is duplication.
    - Add Ubuntu configuration for busybox binaries.


=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  Michael Tokarev <mjt@tls.msk.ru>,
 Build-Depends: debhelper-compat (= 13),
  zip <!nocheck>
-Standards-Version: 4.1.5
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/installer-team/busybox.git
 Vcs-Browser: https://salsa.debian.org/installer-team/busybox
 Homepage: http://www.busybox.net
@@ -32,7 +32,7 @@
  This package installs the BusyBox binary but does not install
  symlinks for any of the supported utilities. Some of the utilities
  can be used in the system by installing the busybox-syslogd,
- busybox-udhcpc or busybox-udhcpd packages.
+ udhcpc or udhcpd packages.
 
 Package: busybox-static
 Architecture: any
@@ -97,7 +97,6 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
  busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}),
- lsb-base,
  ${misc:Depends},
 Provides: linux-kernel-log-daemon, system-log-daemon
 Conflicts: linux-kernel-log-daemon, system-log-daemon
@@ -122,15 +121,15 @@
 
 Package: udhcpc
 Section: net
-Architecture: linux-any
+# busybox dhcpc is linux-specific
+Architecture: all
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
  busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}),
  ${misc:Depends},
-Multi-Arch: same
 Description: Provides the busybox DHCP client implementation
  Busybox contains a very small yet fully functional RFC compliant DHCP
- client formerly known as udhcpc.
+ client udhcpc.
  .
  This package contains the glue to use the busybox udhcpc as DHCP
  client in the system by providing the appropriate symbolic links and
@@ -138,16 +137,16 @@
 
 Package: udhcpd
 Section: net
-Architecture: linux-any
+# busybox dhcpd is linux-specific
+Architecture: all
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
  busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}),
- lsb-base,
  ${misc:Depends},
 Provides: dhcpd
 Description: Provides the busybox DHCP server implementation
  Busybox contains a very small yet fully function RFC compliant DHCP
- server formerly known as udhcpd.
+ server udhcpd.
  .
  This package contains the glue to use the busybox udhcpd as DHCP
  server in the system by providing the appropriate symbolic links and
